// MainDlg.cpp : implementation of the CMainDlg class
//
/////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "resource.h"

#include "MainDlg.h"

// Ƿ PE ļ
BOOL IsPeLike(LPVOID lpImageBase)
{
	PIMAGE_DOS_HEADER	pDosHeader;
	PIMAGE_NT_HEADERS	pNtHeader;

	pDosHeader	=	(PIMAGE_DOS_HEADER)lpImageBase;
	
	if (IMAGE_DOS_SIGNATURE != pDosHeader->e_magic)	return	FALSE;

	pNtHeader	=	(PIMAGE_NT_HEADERS)((DWORD)pDosHeader + pDosHeader->e_lfanew);
	// ƫڽṹ巶Χ֮⣬˵Ǵġ
	if((DWORD)pDosHeader->e_lfanew > ((DWORD)lpImageBase + sizeof(IMAGE_DOS_HEADER) + sizeof(IMAGE_NT_HEADERS)))	return	FALSE;
	if ((DWORD)pNtHeader > ((DWORD)lpImageBase + sizeof(IMAGE_DOS_HEADER) + sizeof(IMAGE_NT_HEADERS)))	return	FALSE;

	if (IMAGE_NT_SIGNATURE != pNtHeader->Signature)	return	FALSE;

	return	TRUE;
}

// ȡ PE ļʵС
DWORD WINAPI GetRealSize(LPVOID	lpImageBase)
{
//	HANDLE	hFile, hMapFile;
//	LPVOID	lpImageBase;
	PIMAGE_DOS_HEADER	pDosHeader;
	PIMAGE_NT_HEADERS	pNtHeader;
	PIMAGE_FILE_HEADER	pFileHeader;
//	PIMAGE_OPTIONAL_HEADER	pOptionalHeader;
	PIMAGE_SECTION_HEADER	pSectionHeader;
/*	
	hFile	=	CreateFile(csFile.GetBuffer(MAX_PATH), GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);

	if (INVALID_HANDLE_VALUE == hFile)	return 0;

	hMapFile	=	CreateFileMapping(hFile, NULL, PAGE_READONLY, 0, 0, NULL);

	if (NULL == hMapFile)
	{
		CloseHandle(hFile);
		return 0;
	}

	CloseHandle(hFile);
	lpImageBase	=	MapViewOfFile(hMapFile, FILE_MAP_READ, 0, 0, 0);

	if (NULL == lpImageBase)
	{
		CloseHandle(hMapFile);
		return 0;
	}

	CloseHandle(hMapFile);
*/
	pDosHeader	=	(PIMAGE_DOS_HEADER)lpImageBase;
	pNtHeader	=	(PIMAGE_NT_HEADERS)((DWORD)pDosHeader + pDosHeader->e_lfanew);
	pSectionHeader	=	IMAGE_FIRST_SECTION(pNtHeader);
	pFileHeader	=	(PIMAGE_FILE_HEADER)&pNtHeader->FileHeader;
//	pOptionalHeader	=	(PIMAGE_OPTIONAL_HEADER)&pNtHeader->OptionalHeader;
	pSectionHeader	+=	(pFileHeader->NumberOfSections - 1);	//λһĿͷ
//	UnmapViewOfFile(lpImageBase);

	return (pSectionHeader->PointerToRawData + pSectionHeader->SizeOfRawData); // ļʵʴС = ļβƫ = һεĴƫ + һεĴ̴С

}

LPTSTR	WINAPI GetRealType(LPVOID lpImageBase)
{
	PIMAGE_DOS_HEADER	pDosHeader;
	PIMAGE_NT_HEADERS	pNtHeader;
	PIMAGE_FILE_HEADER	pFileHeader;
	PIMAGE_OPTIONAL_HEADER	pOptionalHeader;

	pDosHeader	=	(PIMAGE_DOS_HEADER)lpImageBase;
	pNtHeader	=	(PIMAGE_NT_HEADERS)((DWORD)pDosHeader + pDosHeader->e_lfanew);
	pFileHeader	=	(PIMAGE_FILE_HEADER)&pNtHeader->FileHeader;
	pOptionalHeader	=	(PIMAGE_OPTIONAL_HEADER)&pNtHeader->OptionalHeader;
	
	// жӳ
	if (IMAGE_FILE_DLL & pFileHeader->Characteristics)	return	_T(".dll");
	if ((IMAGE_FILE_EXECUTABLE_IMAGE & pFileHeader->Characteristics) && (IMAGE_SUBSYSTEM_NATIVE & pOptionalHeader->Subsystem))	return	_T(".sys");
	if (IMAGE_FILE_EXECUTABLE_IMAGE & pFileHeader->Characteristics)	return	_T(".exe");

	return	_T(".bin"); //ĬϷغ׺ .bin
}

LRESULT CMainDlg::OnInitDialog(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
{
	// center the dialog on the screen
	CenterWindow();

	// set icons
	HICON hIcon = (HICON)::LoadImage(_Module.GetResourceInstance(), MAKEINTRESOURCE(IDR_MAINFRAME), 
		IMAGE_ICON, ::GetSystemMetrics(SM_CXICON), ::GetSystemMetrics(SM_CYICON), LR_DEFAULTCOLOR);
	SetIcon(hIcon, TRUE);
	HICON hIconSmall = (HICON)::LoadImage(_Module.GetResourceInstance(), MAKEINTRESOURCE(IDR_MAINFRAME), 
		IMAGE_ICON, ::GetSystemMetrics(SM_CXSMICON), ::GetSystemMetrics(SM_CYSMICON), LR_DEFAULTCOLOR);
	SetIcon(hIconSmall, FALSE);

	m_csFile = _T("");
	DragAcceptFiles(TRUE); // Ϸ

	return TRUE;
}

LRESULT CMainDlg::OnAppAbout(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	CSimpleDialog<IDD_ABOUTBOX, FALSE> dlg;
	dlg.DoModal();
	return 0;
}

LRESULT CMainDlg::OnOK(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	// TODO: Add validation code 
	EndDialog(wID);
	return 0;
}

LRESULT CMainDlg::OnCancel(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	EndDialog(wID);
	return 0;
}

LRESULT CMainDlg::OnBnClickedBtnSelect(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	OPENFILENAME ofn;
	ZeroMemory(&ofn, sizeof(ofn));
	ofn.Flags	=	OFN_HIDEREADONLY|OFN_PATHMUSTEXIST;
	ofn.lStructSize	=	sizeof(ofn);
	ofn.nMaxFile	=	MAX_PATH;
	ofn.lpstrFilter	=	_T("ִļ (*.exe)\0*.exe\0̬ӿ (*.dll)\0*.dll\0ļ (*.*)\0*.*\0\0");
	ofn.lpstrTitle	=	_T("ѡļ");
	ofn.lpstrFile	=	m_csFile.GetBuffer(MAX_PATH);

	if (!GetOpenFileName(&ofn)) 
	{
		m_csFile.ReleaseBuffer();
		return 0;
	}

	m_csFile.ReleaseBuffer();
	DoDataExchange(FALSE);

	return 0;
}

LRESULT CMainDlg::OnBnClickedBtnExtract(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	DoDataExchange(TRUE);
	BOOL	bFound;
	HANDLE	hFile, hMapFile;
	LPVOID	lpImageBase;
	DWORD	dwWrited, dwFileSize, dwHiSize, dwRealSize, dwCounter;
	LPBYTE	lpByte;
	CString	csFileToSave, csInfo, csLog, csTmp;

	if (m_csFile.IsEmpty())	return	0;

	hFile	=	CreateFile(m_csFile.GetBuffer(MAX_PATH), GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);

	if (INVALID_HANDLE_VALUE == hFile)	return	0;

	hMapFile	=	CreateFileMapping(hFile, NULL, PAGE_READONLY, 0, 0, NULL);

	if (NULL == hMapFile)	
	{
		CloseHandle(hFile);
		return 0;
	}

	dwFileSize	=	GetFileSize(hFile, &dwHiSize); // ȡļС dwHiSize Ϊ 0 ˵ļ 4Gʱļ
	CloseHandle(hFile);
	lpImageBase	=	MapViewOfFile(hMapFile, FILE_MAP_READ, 0, 0, 0);

	if (NULL == lpImageBase)
	{
		CloseHandle(hMapFile);
		return 0;
	}

	CloseHandle(hMapFile);
	lpByte	=	(LPBYTE)lpImageBase;
	bFound	=	FALSE;
	dwCounter	=	0;

	for (DWORD dwPos = 0; dwPos < dwFileSize; dwPos++, lpByte++)
	{
		if (!IsPeLike(lpByte) || (dwPos == 0))	continue;
		
		dwRealSize	=	GetRealSize(lpByte);
		csFileToSave.Format(_T("%s_~0x%08X%s"),m_csFile, dwPos, GetRealType(lpByte)); // ļеƫƵַΪļ
		hFile	=	CreateFile(csFileToSave.GetBuffer(MAX_PATH), GENERIC_WRITE, FILE_SHARE_READ, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
		csFileToSave.ReleaseBuffer();

		if (INVALID_HANDLE_VALUE == hFile)	continue;

		WriteFile(hFile, lpByte, dwRealSize, &dwWrited, NULL);
		CloseHandle(hFile);
		bFound	=	TRUE;
		++dwCounter;
		csTmp.Format(_T("ļƣ%s\r\nļƫƣ0x%08X (%d)\r\nļС%d (ֽ)\r\n"), csFileToSave, dwPos, dwPos, dwRealSize);
		csLog	+=	csTmp;
	}

	UnmapViewOfFile(lpImageBase);
	if (bFound)	
	{
		csTmp.Format(_T("%s_Extract.log"), m_csFile);
		hFile	=	CreateFile(csTmp.GetBuffer(MAX_PATH), GENERIC_WRITE, FILE_SHARE_READ, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
		WriteFile(hFile, csLog.GetBuffer(0), csLog.GetLength(), &dwWrited, NULL);
		CloseHandle(hFile);
		csInfo.Format(_T("Ŀļҵ %d ļѱ浽ĿļĿ¼С"), dwCounter);
	}
	else	
		csInfo	=	_T("Ŀļûзļ");

	MessageBox(csInfo, _T(""), MB_OK|MB_ICONINFORMATION);

	return 0;
}


void CMainDlg::OnDropFiles(HDROP hDropInfo)
{
	CString	csFile;
	DragQueryFile(hDropInfo, 0, csFile.GetBuffer(MAX_PATH), MAX_PATH);
	
	if (!(FILE_ATTRIBUTE_DIRECTORY & GetFileAttributes(csFile)))
	{
		m_csFile	=	csFile;
		DoDataExchange(FALSE);
	}

	csFile.ReleaseBuffer();
	DragFinish(hDropInfo);
}
